<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services\ManutencaoContaClienteConsService;
use Teknisa\MAN\Services\AtualizaSaldoCons;
use Teknisa\MAN\Services\NovoCodigo;
use Zeedhi\Framework\DTO\Response\Notification;

class ManutencaoContaClienteCons extends CrudWithParameterBag  {

    const CONTACONSUMI = 'vnd00700_manutencaocontaclienteconsumidor';
    
    protected $dataSourceName;
    protected $parameterBagColumns = array('NRORG', 'CDCLIENTE', 'DTMOVCLI');
    
    protected $ManutencaoContaClienteConsService;
    protected $AtualizaSaldocons;
    protected $novoCodigo;
    
    public function __construct(Manager $dataSourceManager, ParameterBag $parameterBag, ManutencaoContaClienteConsService $ManutencaoContaClienteConsService, AtualizaSaldocons $AtualizaSaldocons, NovoCodigo $novoCodigo) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->ManutencaoContaClienteConsService = $ManutencaoContaClienteConsService;
        $this->AtualizaSaldocons = $AtualizaSaldocons;
        $this->novoCodigo = $novoCodigo;
    }
    
    public function findConta(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this::CONTACONSUMI;
        parent::find($request, $response);
    } 
    
    public function saveConta(DTO\Request\DataSet $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        $this->dataSourceName = $this::CONTACONSUMI;
        //$rows[0]['VRMOVCLI'] = str_replace(',', '.', str_replace('.', '', $rows[0]['VRMOVCLI']));
        $rows[0]['DATA'] = $rows[0]['DTMOVIMCLIE'];
        $movclie = 'MOVCLIE'.$rows[0]['CDCLIENTE'];
        if (empty($rows[0]['NRSEQMOVCLI'])) {
            $rows[0]['NRSEQMOVCLI'] = $this->novoCodigo->getCodeByTableName($movclie, $rows[0]['NRORG']);
            $newRequest = new DTO\Request\DataSet(
                new DataSet(
                    $this->dataSourceName,
                    $rows
                ),
                $request->getMethod(),
                $request->getRoutePath(),
                $request->getUserId()
            );
            $dataSet = $newRequest->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            parent::save($newRequest, $response);
        }
        else{
            parent::save($request, $response);
        }
        $this->AtualizaSaldocons->AtualizaSaldoCons($rows[0]);
    } 

}