<?php
        /*************************************************************************
        *    CONTROLLER PARA A FUNÇÃO RECALCULO DE SALDOS PARA CRÉDITO PESSOAL   *
        *   PARA DEBITO PESSOAL: Teknisa\MAN\Controllers\RecalculoSaldoCons      *
        **************************************************************************/
namespace Teknisa\MAN\Controllers;
        
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\EvoluiSaldo;

class RecalculoSaldoConsCredito extends  \Teknisa\MAN\Controllers\TeknisaCrud{


    const dataSourceTipoCons      = 'vnd02800_recalculosaldocons_tipoCons',
          dataSourceConsumidor    = 'vnd09500_manutencaocontaclienteconsfamilia_Consumidor',
          dataSourceCliente       = 'select_cliente_by_filial';

    protected $parameterBagColumnsCliente           = array('NRORG', 'CDFILIAL'),
              $parameterBagColumnsConsumidor        = array('NRORG', 'CDCLIENTE', 'CDFILIAL', 'TCDCONSUMIDOR'),
              $utilService;
    
    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Manager $dataSourceManager, EvoluiSaldo $EvoluiSaldo) {
        $this->crudService               = $crudService;
        $this->parameterBag              = $parameterBag;
        $this->entityManager             = $entityManager;
        $this->utilService               = $utilService;
        $this->dataSourceManager         = $dataSourceManager;
        $this->EvoluiSaldo               = $EvoluiSaldo;
    }
    
    public function findCliente(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = self::dataSourceCliente;
        $this->parameterBagColumns = $this->parameterBagColumnsTipoCons;
        parent::find($request,$response);
    }
    
    public function findConsumidor(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = self::dataSourceConsumidor;
        $this->parameterBagColumns = $this->parameterBagColumnsConsumidor;
        parent::find($request,$response);
    }
    
    public function startRecalc (DTO\Request\Row $request, DTO\Response $response){
        $params = $this->utilService->getParamsAsArray($request);
        $CLIENTE    = ($params['CDCLIENTE']);
        $CONSUMIDOR = ($params['CDCONSUMIDOR']);
        $NRORG      = ($params['NRORG']);
        $parameters = array(
    			'P_CDCLIENTE'   => $CLIENTE,
    			'P_CDCONSUMIDOR'=> $CONSUMIDOR
		);
        $resposta = $this->entityManager->getConnection()->executeQuery(self::ADQ_MIN_SALDO, $parameters)->fetchAll();
        //Comportamento do Gestão de Vendas: se a DTMOVEXTCONS do consumidor é nula, a data é substituida por 30/12/1899
        if($resposta[0]['DTMOVEXTCONS'] == NULL){
            $DTMOVEXTCONS = '30 December 1899';
            $newformat = date("d/m/Y", strtotime($DTMOVEXTCONS));
            //$newformat = date('d-m-Y', $DTMOVEXTCONS);
    		$conditions = array(
    		    'CDCLIENTE'     => $CLIENTE,
    		    'CDCONSUMIDOR'  => $CONSUMIDOR,
    		    'DTMOVEXTCONS'  => $newformat,
    		    'NRORG'         => $NRORG
    		); 
    		$retorno = $this->EvoluiSaldo->EvoluiSaldoFunction($conditions);
            
        } else{
		    $DTMOVEXTCONS = $resposta[0]['DTMOVEXTCONS'];
		    $conditions = array(
		    'CDCLIENTE'     => $CLIENTE,
		    'CDCONSUMIDOR'  => $CONSUMIDOR,
		    'DTMOVEXTCONS'  => $DTMOVEXTCONS,
		    'NRORG'         => $NRORG
		    ); 
		    $retorno = $this->EvoluiSaldo->EvoluiSaldoFunction($conditions);
        }
    }
 
 
    const ADQ_MIN_SALDO = "SELECT A.DTMOVEXTCONS FROM (SELECT MIN(DTMOVEXTCONS) AS DTMOVEXTCONS FROM EXTRATOCONS WHERE (CDCONSUMIDOR = :P_CDCONSUMIDOR) AND (CDCLIENTE = :P_CDCLIENTE )) A";
}