<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use \Zeedhi\Framework\Util\Functions;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelatoriosVendaProduto {
    
    
    protected $RelatoriosVendaProdutoServices;
    protected $utilService;

    public function __construct (Services\RelatoriosVendaProduto $RelatoriosVendaProdutoServices, Utilities\Util $utilService) {
        $this->RelatoriosVendaProdutoServices = $RelatoriosVendaProdutoServices;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        set_time_limit(120);
        $conditions = $this->utilService->getParamsAsArray($request);
    
        if(Functions::arrayKeyExists('CDFILIAL', $conditions)) {
            if(Functions::arrayKeyExists('MODALIDADE2', $conditions)) {
                $conditions['MODALIDADE'] = $conditions['MODALIDADE2'];
            }
            
            $conditions = $this->RelatoriosVendaProdutoServices->buildParamsFaturamento($conditions);
    
            $result = $this->RelatoriosVendaProdutoServices->findRelatorio($conditions);
            
            $response->addDataSet(new DataSet("vnd41201_relVendaProdutoAnalitico", $result));
        }
    }
}